// automatically generated by the FlatBuffers compiler, do not modify

package Serialization;

import java.nio.*;
import java.lang.*;
import java.util.*;
import com.google.flatbuffers.*;

@SuppressWarnings("unused")
public final class StatusChangeLog extends Table {
  public static void ValidateVersion() { Constants.FLATBUFFERS_1_12_0(); }
  public static StatusChangeLog getRootAsStatusChangeLog(ByteBuffer _bb) { return getRootAsStatusChangeLog(_bb, new StatusChangeLog()); }
  public static StatusChangeLog getRootAsStatusChangeLog(ByteBuffer _bb, StatusChangeLog obj) { _bb.order(ByteOrder.LITTLE_ENDIAN); return (obj.__assign(_bb.getInt(_bb.position()) + _bb.position(), _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __reset(_i, _bb); }
  public StatusChangeLog __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public Serialization.BehaviorTree behaviorTree() { return behaviorTree(new Serialization.BehaviorTree()); }
  public Serialization.BehaviorTree behaviorTree(Serialization.BehaviorTree obj) { int o = __offset(4); return o != 0 ? obj.__assign(__indirect(o + bb_pos), bb) : null; }
  public Serialization.StatusChange stateChanges(int j) { return stateChanges(new Serialization.StatusChange(), j); }
  public Serialization.StatusChange stateChanges(Serialization.StatusChange obj, int j) { int o = __offset(6); return o != 0 ? obj.__assign(__vector(o) + j * 16, bb) : null; }
  public int stateChangesLength() { int o = __offset(6); return o != 0 ? __vector_len(o) : 0; }
  public Serialization.StatusChange.Vector stateChangesVector() { return stateChangesVector(new Serialization.StatusChange.Vector()); }
  public Serialization.StatusChange.Vector stateChangesVector(Serialization.StatusChange.Vector obj) { int o = __offset(6); return o != 0 ? obj.__assign(__vector(o), 16, bb) : null; }

  public static int createStatusChangeLog(FlatBufferBuilder builder,
      int behavior_treeOffset,
      int state_changesOffset) {
    builder.startTable(2);
    StatusChangeLog.addStateChanges(builder, state_changesOffset);
    StatusChangeLog.addBehaviorTree(builder, behavior_treeOffset);
    return StatusChangeLog.endStatusChangeLog(builder);
  }

  public static void startStatusChangeLog(FlatBufferBuilder builder) { builder.startTable(2); }
  public static void addBehaviorTree(FlatBufferBuilder builder, int behaviorTreeOffset) { builder.addOffset(0, behaviorTreeOffset, 0); }
  public static void addStateChanges(FlatBufferBuilder builder, int stateChangesOffset) { builder.addOffset(1, stateChangesOffset, 0); }
  public static void startStateChangesVector(FlatBufferBuilder builder, int numElems) { builder.startVector(16, numElems, 8); }
  public static int endStatusChangeLog(FlatBufferBuilder builder) {
    int o = builder.endTable();
    return o;
  }

  public static final class Vector extends BaseVector {
    public Vector __assign(int _vector, int _element_size, ByteBuffer _bb) { __reset(_vector, _element_size, _bb); return this; }

    public StatusChangeLog get(int j) { return get(new StatusChangeLog(), j); }
    public StatusChangeLog get(StatusChangeLog obj, int j) {  return obj.__assign(__indirect(__element(j), bb), bb); }
  }
}

